post
/public_api/v1/widgets/insert
Update or add the widgets retrieved by the Get widgets API.
You must have Instance Administrator permissions to run this endpoint.
Request headers
Authorization
String
required
{api_key}
{api_key}
Example:
authorization_example
x-xdr-auth-id
String
required
{api_key_id}
{api_key_id}
Example:
xXdrAuthId_example
CLIENT REQUEST
curl -X 'POST'
-H
'Accept: application/json'
-H
'Content-Type: application/json'
-H
'Authorization: authorization_example'
-H
'x-xdr-auth-id: xXdrAuthId_example'
'https://api-yourfqdn/public_api/v1/widgets/insert'
-d
''
import http.client
conn = http.client.HTTPSConnection("api-yourfqdn")
payload = "{\"request_data\":[{\"widgets_data\":[{\"widget_key\":\"string\",\"title\":\"string\",\"creation_time\":0,\"description\":\"string\",\"data\":{\"phrase\":\"string\",\"time_frame\":{\"relativeTime\":0},\"viewOptions\":{\"type\":\"string\",\"commands\":[{}]},\"gridRawStorageInfo\":{\"sort\":\"string\",\"coldefs\":{},\"rowHeight\":\"string\",\"columnWidth\":0}},\"support_time_range\":true,\"additional_info\":{\"query_tables\":[\"string\"],\"query_uses_library\":true},\"creator_mail\":\"string\"}]}]}"
headers = {
'Authorization': "SOME_STRING_VALUE",
'x-xdr-auth-id': "SOME_STRING_VALUE",
'content-type': "application/json"
}
conn.request("POST", "/public_api/v1/widgets/insert", payload, headers)
res = conn.getresponse()
data = res.read()
print(data.decode("utf-8"))require 'uri'
require 'net/http'
require 'openssl'
url = URI("https://api-yourfqdn/public_api/v1/widgets/insert")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
http.verify_mode = OpenSSL::SSL::VERIFY_NONE
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'SOME_STRING_VALUE'
request["x-xdr-auth-id"] = 'SOME_STRING_VALUE'
request["content-type"] = 'application/json'
request.body = "{\"request_data\":[{\"widgets_data\":[{\"widget_key\":\"string\",\"title\":\"string\",\"creation_time\":0,\"description\":\"string\",\"data\":{\"phrase\":\"string\",\"time_frame\":{\"relativeTime\":0},\"viewOptions\":{\"type\":\"string\",\"commands\":[{}]},\"gridRawStorageInfo\":{\"sort\":\"string\",\"coldefs\":{},\"rowHeight\":\"string\",\"columnWidth\":0}},\"support_time_range\":true,\"additional_info\":{\"query_tables\":[\"string\"],\"query_uses_library\":true},\"creator_mail\":\"string\"}]}]}"
response = http.request(request)
puts response.read_bodyconst data = JSON.stringify({
"request_data": [
{
"widgets_data": [
{
"widget_key": "string",
"title": "string",
"creation_time": 0,
"description": "string",
"data": {
"phrase": "string",
"time_frame": {
"relativeTime": 0
},
"viewOptions": {
"type": "string",
"commands": [
{}
]
},
"gridRawStorageInfo": {
"sort": "string",
"coldefs": {},
"rowHeight": "string",
"columnWidth": 0
}
},
"support_time_range": true,
"additional_info": {
"query_tables": [
"string"
],
"query_uses_library": true
},
"creator_mail": "string"
}
]
}
]
});
const xhr = new XMLHttpRequest();
xhr.withCredentials = true;
xhr.addEventListener("readystatechange", function () {
if (this.readyState === this.DONE) {
console.log(this.responseText);
}
});
xhr.open("POST", "https://api-yourfqdn/public_api/v1/widgets/insert");
xhr.setRequestHeader("Authorization", "SOME_STRING_VALUE");
xhr.setRequestHeader("x-xdr-auth-id", "SOME_STRING_VALUE");
xhr.setRequestHeader("content-type", "application/json");
xhr.send(data);HttpResponse<String> response = Unirest.post("https://api-yourfqdn/public_api/v1/widgets/insert")
.header("Authorization", "SOME_STRING_VALUE")
.header("x-xdr-auth-id", "SOME_STRING_VALUE")
.header("content-type", "application/json")
.body("{\"request_data\":[{\"widgets_data\":[{\"widget_key\":\"string\",\"title\":\"string\",\"creation_time\":0,\"description\":\"string\",\"data\":{\"phrase\":\"string\",\"time_frame\":{\"relativeTime\":0},\"viewOptions\":{\"type\":\"string\",\"commands\":[{}]},\"gridRawStorageInfo\":{\"sort\":\"string\",\"coldefs\":{},\"rowHeight\":\"string\",\"columnWidth\":0}},\"support_time_range\":true,\"additional_info\":{\"query_tables\":[\"string\"],\"query_uses_library\":true},\"creator_mail\":\"string\"}]}]}")
.asString();import Foundation
let headers = [
"Authorization": "SOME_STRING_VALUE",
"x-xdr-auth-id": "SOME_STRING_VALUE",
"content-type": "application/json"
]
let parameters = ["request_data": [["widgets_data": [
[
"widget_key": "string",
"title": "string",
"creation_time": 0,
"description": "string",
"data": [
"phrase": "string",
"time_frame": ["relativeTime": 0],
"viewOptions": [
"type": "string",
"commands": [[]]
],
"gridRawStorageInfo": [
"sort": "string",
"coldefs": [],
"rowHeight": "string",
"columnWidth": 0
]
],
"support_time_range": true,
"additional_info": [
"query_tables": ["string"],
"query_uses_library": true
],
"creator_mail": "string"
]
]]]] as [String : Any]
let postData = JSONSerialization.data(withJSONObject: parameters, options: [])
let request = NSMutableURLRequest(url: NSURL(string: "https://api-yourfqdn/public_api/v1/widgets/insert")! as URL,
cachePolicy: .useProtocolCachePolicy,
timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data
let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
if (error != nil) {
print(error)
} else {
let httpResponse = response as? HTTPURLResponse
print(httpResponse)
}
})
dataTask.resume()<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api-yourfqdn/public_api/v1/widgets/insert",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => "{\"request_data\":[{\"widgets_data\":[{\"widget_key\":\"string\",\"title\":\"string\",\"creation_time\":0,\"description\":\"string\",\"data\":{\"phrase\":\"string\",\"time_frame\":{\"relativeTime\":0},\"viewOptions\":{\"type\":\"string\",\"commands\":[{}]},\"gridRawStorageInfo\":{\"sort\":\"string\",\"coldefs\":{},\"rowHeight\":\"string\",\"columnWidth\":0}},\"support_time_range\":true,\"additional_info\":{\"query_tables\":[\"string\"],\"query_uses_library\":true},\"creator_mail\":\"string\"}]}]}",
CURLOPT_HTTPHEADER => [
"Authorization: SOME_STRING_VALUE",
"content-type: application/json",
"x-xdr-auth-id: SOME_STRING_VALUE"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}CURL *hnd = curl_easy_init();
curl_easy_setopt(hnd, CURLOPT_CUSTOMREQUEST, "POST");
curl_easy_setopt(hnd, CURLOPT_URL, "https://api-yourfqdn/public_api/v1/widgets/insert");
struct curl_slist *headers = NULL;
headers = curl_slist_append(headers, "Authorization: SOME_STRING_VALUE");
headers = curl_slist_append(headers, "x-xdr-auth-id: SOME_STRING_VALUE");
headers = curl_slist_append(headers, "content-type: application/json");
curl_easy_setopt(hnd, CURLOPT_HTTPHEADER, headers);
curl_easy_setopt(hnd, CURLOPT_POSTFIELDS, "{\"request_data\":[{\"widgets_data\":[{\"widget_key\":\"string\",\"title\":\"string\",\"creation_time\":0,\"description\":\"string\",\"data\":{\"phrase\":\"string\",\"time_frame\":{\"relativeTime\":0},\"viewOptions\":{\"type\":\"string\",\"commands\":[{}]},\"gridRawStorageInfo\":{\"sort\":\"string\",\"coldefs\":{},\"rowHeight\":\"string\",\"columnWidth\":0}},\"support_time_range\":true,\"additional_info\":{\"query_tables\":[\"string\"],\"query_uses_library\":true},\"creator_mail\":\"string\"}]}]}");
CURLcode ret = curl_easy_perform(hnd);var client = new RestClient("https://api-yourfqdn/public_api/v1/widgets/insert");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "SOME_STRING_VALUE");
request.AddHeader("x-xdr-auth-id", "SOME_STRING_VALUE");
request.AddHeader("content-type", "application/json");
request.AddParameter("application/json", "{\"request_data\":[{\"widgets_data\":[{\"widget_key\":\"string\",\"title\":\"string\",\"creation_time\":0,\"description\":\"string\",\"data\":{\"phrase\":\"string\",\"time_frame\":{\"relativeTime\":0},\"viewOptions\":{\"type\":\"string\",\"commands\":[{}]},\"gridRawStorageInfo\":{\"sort\":\"string\",\"coldefs\":{},\"rowHeight\":\"string\",\"columnWidth\":0}},\"support_time_range\":true,\"additional_info\":{\"query_tables\":[\"string\"],\"query_uses_library\":true},\"creator_mail\":\"string\"}]}]}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);Body parameters
application/json
request_dataarray
[widgets_dataarray
]
widgets_dataarrayAn array of widget details as retrieved by the Get widgets API.
An array of widget details as retrieved by the Get widgets API.
[widget_keystring
titlestring
creation_timeinteger
descriptionstring
dataobject
phrasestring
time_frameobject
relativeTimeinteger
viewOptionsobject
typestring
commandsarray
gridRawStorageInfoobject
sortstring
coldefsobject
rowHeightstring
columnWidthinteger
support_time_rangeboolean
additional_infoobject
query_tablesarray[string]
query_uses_libraryboolean
creator_mailstring
]
widget_keystring
titlestring
creation_timeinteger
descriptionstring
dataobject
phrasestring
time_frameobject
relativeTimeinteger
viewOptionsobject
typestring
commandsarray
[]
gridRawStorageInfoobject
sortstring
coldefsobject
rowHeightstring
columnWidthinteger
support_time_rangeboolean
additional_infoobject
query_tablesarray[string]
query_uses_libraryboolean
creator_mailstring
REQUEST
{
"request_data": [
{
"widgets_data": [
{
"widget_key": "xql_1646052681403",
"title": "Widget A",
"creation_time": 1653303166334,
"description": null,
"data": {
"phrase": "cold_dataset = endpoints",
"time_frame": {
"relativeTime": 86400000
},
"viewOptions": {
"type": "table",
"commands": []
}
},
"support_time_range": true,
"additional_info": {
"query_tables": [
"endpoints"
],
"query_uses_library": false
},
"creator_mail": "user@company.com"
}
]
},
{
"widgets_data": [
{
"widget_key": "xql_1346826725701",
"title": "Widget B",
"creation_time": 1653302483610,
"description": null,
"data": {
"phrase": "dataset = endpoints ",
"time_frame": {
"relativeTime": 86400000
},
"viewOptions": {
"type": "table",
"commands": []
},
"gridRawStorageInfo": {
"sort": null,
"coldefs": {},
"rowHeight": "{\"rowHeight\":\"regular\",\"gridRowsHeight\":\"medium-row\"}",
"columnWidth": null
}
},
"support_time_range": true,
"additional_info": {
"query_tables": [
"endpoints"
],
"query_uses_library": false
},
"creator_mail": "user@company.com"
}
]
}
]
}Responses